=== modified file 'cmdline/apt-get.cc'
--- cmdline/apt-get.cc	2010-12-03 16:06:34 +0000
+++ cmdline/apt-get.cc	2010-12-03 17:05:52 +0000
@@ -1873,16 +1873,15 @@
 	 pkgCache::PkgIterator I(Cache,Cache.List[J]);
 	 if ((*Cache)[I].Install() == false)
 	    continue;
-
-	 const char **J;
-	 for (J = CmdL.FileList + 1; *J != 0; J++)
-	    if (strcmp(*J,I.Name()) == 0)
-		break;
-	 
-	 if (*J == 0) {
-	    List += I.FullName(true) + " ";
-	    VersionsList += string(Cache[I].CandVersion) + "\n";
-	 }
+	 pkgCache::VerIterator Cand = Cache[I].CandidateVerIter(Cache);
+	 if (Cand.Pseudo() == true)
+	    continue;
+
+	 if (verset[MOD_INSTALL].find(Cand) != verset[MOD_INSTALL].end())
+	    continue;
+
+	 List += I.FullName(true) + " ";
+	 VersionsList += string(Cache[I].CandVersion) + "\n";
       }
       
       ShowList(c1out,_("The following extra packages will be installed:"),List,VersionsList);

=== modified file 'debian/changelog'
--- debian/changelog	2010-12-03 16:06:34 +0000
+++ debian/changelog	2010-12-03 17:05:52 +0000
@@ -13,10 +13,12 @@
       in the autoremove section and installing those (Closes: #604222)
     - change pkg/release behavior to use the new SetCandidateRelease
       so installing packages from experimental or backports is easier
+    - really do not show packages in the extra section if they were
+      requested on the commandline, e.g. with a modifier
   * debian/control:
     - add Vcs-Browser now that loggerhead works again (Closes: #511168)
 
- -- David Kalnischkies <kalnischkies@gmail.com>  Fri, 03 Dec 2010 17:06:28 +0100
+ -- David Kalnischkies <kalnischkies@gmail.com>  Fri, 03 Dec 2010 17:30:52 +0100
 
 apt (0.8.10) unstable; urgency=low
 

